
module.exports = function emitRedirect (emitFile) {
    return function _emitRedirect (file_path, target_url, metadata={}) {

        // allow addition metadata to be added to redirect_metadata
        // useful for open-graph tags
        let metatags = ''
        for (let key in metadata) {
            metatags = `${metatags}
            <meta property="${key}" content="${metadata[key]}" />`
        }

        // In case they end up on the page directly anyway. (Can happen under
        // certain built-in hosts for S3 static hosting, and for local testing.)
        const file_content = `
            <!doctype html><html><head>
            <meta http-equiv="refresh" content="0;url=${ target_url }" />
            ${metatags}
            </head><body></body></html>
        `
        emitFile(file_path, file_content, {
            content_type: 'text/html',
            metadata: {
                'website-redirect-location': target_url,
                'Content-Type': 'text/html',
            },
        })

    }
}
